<?php
/**
 * @file
 *   Tycoon callbacks.
 */

/**
 * Implements hook_webapi_call_prepare().
 */
function tycoon_webapi_site_manager_tycoon_webapi_call_prepare($data) {
  if ($data['command']['command'] == 'checkAuth') {
    $api_key = $data['post']['api_key'];
    $q = db_select('tycoon_webapi_keys', 'k')
      ->condition('k.api_key', $api_key);
    $q->join('tycoon_webapi_keys_strict', 's', 's.kid = k.kid');
    $strict = $q->fields('s')
      ->execute()
      ->fetch();
    if ($strict->strict == 1) {
      //Strict mode checking is on. Ensure that the ip that is making this call is correct
      $ip = ip_address();
      $ip_check = db_select('tycoon_webapi_sites', 's')
        ->condition('kid', $strict->kid)
        ->condition('ip', $ip)
        ->fields('s')
        ->execute();
      if ($ip_check->rowCount() < 1) {
        $e = new TycoonWebAPIException('Access Denied. The API key you have supplied does not have the proper access.', $command['command'], 403);
        throw $e;
      }
    }
  }
}

/**
 * Implements hook_webapi_call_process().
 */
function tycoon_webapi_site_manager_tycoon_webapi_call_process($data) {
  $api_key = $data['post']['api_key'];
  $q = db_select('tycoon_webapi_keys', 'k')
    ->condition('k.api_key', $api_key);
  $q->join('tycoon_webapi_keys_strict', 's', 's.kid = k.kid');
  $strict = $q->fields('s')
    ->execute()
    ->fetch();
  if (variable_get('tycoon_webapi_site_log_all', 0) || (!empty($strict) && $strict->log == 1)) {
    $data['ip'] = ip_address();
    $data['site'] = db_select('tycoon_webapi_sites', 's')
      ->condition('s.kid', $strict->kid)
      ->condition('s.ip', $data['ip'])
      ->fields('s', array('sid', 'name'))
      ->execute()
      ->fetchAllKeyed(0,1);
    $log['message'] = '!command called from !ip';
    $log['command'] = $data['command']['command'];
    $log['args'] = array('!ip' => $data['ip'], '!command' => $data['command']['command']);
    $log['data'] = $data;
    $log['created'] = time();
    $log['kid'] = $strict->kid;
    drupal_write_record('tycoon_webapi_sites_log', $log);
  }
}
  